urls.py
from django.conf.urls import url
from . import views


app_name = 'pmp'
urlpatterns = [
    url(r'^$', views.IndexView.as_view(), name='index'),
    url(r'^cat/(?P<slug>\w+)/$', views.CateView.as_view(), name='cate'),
    url(r'^cat/(?P<category>\w+)/question/(?P<pk>\d+)/$',
        views.CQView.as_view(), name='cqdetail'),
    url(r'^new/$', views.add_new, name='add_new'),
    url(r'^question/(?P<pk>\d+)/edit/$', views.edit_question, name='edit'),
    url(r'^question/(?P<pk>\d+)/$', views.QView.as_view(), name='detail'),
    url(r'^question/(?P<pk>\d+)/result/$', views.RView.as_view(), name='result'),
    url(r'^question/(?P<question_id>\d+)/choose/$', views.choose, name='choose'),
]

models.py
from django.db import models
from tinymce import HTMLField


# Create your models here.
# Table 1: Question:
class Question(models.Model):
    # 1. Question Text
    # question_text = models.TextField(
    #     'Question subject',
    #     max_length=500,
    # )
    question_text = HTMLField('Question Subject')

    def __str__(self):
        return self.question_text

    # 2. Answer to Question
    ANSWERS = (
        ('A', 'A'),
        ('B', 'B'),
        ('C', 'C'),
        ('D', 'D'),
    )
    answer = models.CharField(
        'The answer to the question',
        max_length=1,
        choices=ANSWERS,
        null=True, blank=True
    )

    # 3. which chapter this question belong 2
    chapter = models.CharField(
        'Question belong to Which chapter',
        max_length=2,
        null=True, blank=True
    )

    # 4. How to analysis this question
    description = models.TextField(
        'The analysis for this question.',
        max_length=1000,
        null=True, blank=True
    )

    # 5. This question has been learned or not
    leanred = models.BooleanField(
        'Mark it as learned.',
        default=False
    )

    # 6. Question Category
    category = models.CharField(
        'Where this question come from?',
        max_length=20,
        null=True,
        blank=True,
        default=''
    )


# Table 2: Options:
class Options(models.Model):
    # 1. Foreign Key
    question = models.ForeignKey(Question, on_delete=models.CASCADE)

    # 2.0 Options index to this question
    OPTION_INDEX = (
        ('A', 'A'),
        ('B', 'B'),
        ('C', 'C'),
        ('D', 'D'),
    )
    option_index = models.CharField(
        'Options to the question',
        max_length=1,
        choices=OPTION_INDEX,
        default='A'
    )
    # 2.1 Options to this question
    option_text = models.CharField(
        'Options to the question',
        max_length=100,
    )

    def __str__(self):
        return self.option_index + '. ' + self.option_text

    # 3. How many this option was selected.
    votes = models.IntegerField(default=0)

templates/pmpexam/add_new.html
{% extends 'pmpexam/base.html' %}
{% load bootstrap3 %}
<!-- For tinymce -->


{% block content %}
    <h2>Add a New Question</h2>

    <form method="POST">
        {% csrf_token %}
        {% bootstrap_form qform layout='grid' %}
        {% for o in oforms %}
            {% bootstrap_form o layout='grid' %}
        {% endfor %}
        <button type="submit">
            Save
        </button>
    </form>
{% endblock %}

templates/pmpexam/base.html
{% load static %}

<!doctype html>
<html>
    <head>
        <title>PMP Test</title>
        <meta charset="utf-8" />
        <script src="https://d3js.org/d3.v4.js"></script>

        <!-- This line Solve glyn icon not show in IE-->
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        {% load bootstrap3 %}
        {% bootstrap_css %}
        {% bootstrap_javascript %}

        <!-- Below is personal css -->
        <link rel="stylesheet" type="text/css" href="{% static 'pmpexam/pmp.css' %}" >
        <link rel="shortcut icon" href="{% static 'pmpexam/favicon.ico' %}"/>
    </head>
    <body>
        <div class="page-header">
            <h1><a href="{% url 'pmp:index' %}">PMP Exam Learning</a></h1>
            {% if user.is_authenticated %}
                Welcome {{ request.user.username }}! You can add a 
                <a href="{% url 'pmp:add_new' %}" class="top-menu">New Question</a>
            {% endif %}
        </div>
        <div class="content container">
            <div class="row">
                <div class="col-md-8">
                    {% block content %}
                    {% endblock %}
                </div>
            </div>
        </div>
    </body>
</html>

templates/pmpexam/cate.html
{% extends 'pmpexam/base.html' %}
{% load bootstrap3 %}
{% load pmp_extras %}

{% block content %}
    <p>Blow is the question list from category: <strong>{{ cate }}</strong></p>
    <p>Choose a question from below <strong>question Lists:</strong></p>
    <table>
        {% for key, value in q_no.items %}
            {% if key|divided:"10" == 0 %}
                    <td>
                        <a href="{% url 'pmp:cqdetail' cate value %}">{{ key }}</a>
                    </td>
                </tr>
            {% else %}
                <td>
                    <a href="{% url 'pmp:cqdetail' cate value %}">{{ key }}</a>
                </td>
            {% endif %}
        {% endfor %}
    </table>
{% endblock %}

templates/pmpexam/cqdetail.html
{% extends 'pmpexam/base.html' %}

{% block content %}
    <p>
        Back to: <a href="{% url 'pmp:cate' cate %}">{{ cate }}</a>
    </p>
    <strong>Question:</strong> {{ question|safe }}

    {% if error_message %}
        <p><strong>{{ error_message }}</strong></p>
    {% endif %}

    <form action="{% url 'pmp:choose' question.id %}" method="post">
        {% csrf_token %}
        {% for option in question.options_set.all %}
            <input type="radio"
                   name="option"
                   id="option{{ option.option_index }}"
                   value="{{ option.id}}"/>
            <label for="option{{ option.option_index }}">
                {{ option.option_index }}.  {{ option.option_text }}
            </label><br />
        {% endfor %}
        <input type="submit" value="Choose" />
    </form>
    <br />
    <p>
        <table>
            <td>
                <a href="{% url 'pmp:result' question.id %}">Check Result</a>
            </td>
            <td>
                {% if question.id in question_id_list|slice:":-1" %}
                    <a href="{% url 'pmp:cqdetail' cate next_id %}">Next</a>
                {% else %}
                    No More Questions.
                {% endif %}
            </td>
    </p>
{% endblock %}

templates/pmpexam/detail.html
{% extends 'pmpexam/base.html' %}

{% block content %}
    <strong>Question:</strong> {{ question|linebreaks }}

    {% if error_message %}
        <p><strong>{{ error_message }}</strong></p>
    {% endif %}

    <form action="{% url 'pmp:choose' question.id %}" method="post">
        {% csrf_token %}
        {% for option in question.options_set.all %}
            <input type="radio"
                   name="option"
                   id="option{{ option.option_index }}"
                   value="{{ option.id}}"/>
            <label for="option{{ option.option_index }}">
                {{ option.option_index }}.  {{ option.option_text }}
            </label><br />
        {% endfor %}
        <input type="submit" value="Choose" />
    </form>
    <br />
    <p>
        <table>
            <td>
                <a href="{% url 'pmp:result' question.id %}">Check Result</a>
            </td>
            <td>
                {% if question_number > question.id %}
                    <a href="{% url 'pmp:detail' next_id %}">Next</a>
                {% else %}
                    No More Questions.
                {% endif %}
            </td>
    </p>
{% endblock %}

templates/pmpexam/edit_question.html
{% extends 'pmpexam/base.html' %}
{% load bootstrap3 %}

{% block content %}
    <h2>Edit Below Question</h2>

    <form method="POST">
        {% csrf_token %}
        {% bootstrap_form qform layout='grid' %}
        <button type="submit">
            Save
        </button>
    </form>
{% endblock %}

templates/pmpexam/index.html
{% extends 'pmpexam/base.html' %}
{% load bootstrap3 %}

{% block content %}
    {% if category_list %}
        <p>Choose from below  <strong>Categories:</strong></p>
        <table>
            <thead>
                <td>No.</td>
                <td>Category</td>
                <td>Questions</td>
            </thead>
            <tbody>
                {% for key, value in cate_data.items %}
                    <tr>
                        <td>{{ forloop.counter }}</td>
                        <td>
                            <a href="{% url 'pmp:cate' key %}">{{ key }}</a>
                        </td>
                        <td>{{ value }}</td>
                    </tr>
                {% endfor %}
            </tbody>
        </table>
    {% else %}
        <p>No Data</p>
    {% endif %}
    
    <br />
    <p>
        {% if "Mobile" in agent %}
            {% bootstrap_icon 'phone' %}
        {% endif %}
    </p>
{% endblock %}

templates/pmpexam/result.html
{% extends 'pmpexam/base.html' %}
{% load pmp_extras %}

{% block content %}
    <strong>Question:</strong> {{ question|linebreaks }}

    {% if error_message %}
        <p><strong>{{ error_message }}</strong></p>
    {% endif %}

    {% for option in question.options_set.all %}
        <div class="chart">
            [{{ option.votes }}]
            <div style="width: {{ option.votes|multiply:"10" }}px;" class="bar">{{ option.votes }}</div>
            {{ option.option_index }}.  {{ option.option_text }}
        </div>
    {% endfor %}

    <br />
    <table>
        <td>
            {% if question_number > question.id %}
                <a href="{% url "pmp:detail" next_id %}">Next</a>
            {% else %}
                No more questions.
            {% endif %}
        </td>
    </table>

    <br />
    {% if question.answer == None %}
        <p></p>
    {% else %}
        <p>
            <div class="answer">
                <strong>Answer: </strong>
                {{ question.answer }}
            </div>
        </p>
    {% endif %}
    {% if question.chapter == None %}
        <p></p>
    {% else %}
        <p>
            <div class="chapter">
                <strong>Chapter: </strong>                
                {{ question.chapter }}
            </div>
        </p>
    {% endif %}
    {% if question.description == None %}
        <p></p>
    {% else %}
        <p>
            <div class="answer">
                <strong>Analysis: </strong><br />
                {{ question.description|linebreaks }}
            </div>
        </p>
    {% endif %}
    {% if user.is_authenticated %}
        <p>
            <table>
                <td>
                    <a href="{% url "pmp:edit" question.id %}">Edit</a>
                </td>
            </table>
        </p>
    {% endif %}
{% endblock %}